// sample to illustrate simple inheritance with functions

class CTestBase
{
public:
    int _iA;
    int _iB;

    CTestBase( int iA, int iB )
    : _iA( iA )
    , _iB( iB )
    {}

    int SumBase( void )
    {
        return _iA + _iB;
    }
};

class CTestDerived
: public CTestBase
{
public:
    int _iC;
    int _iD;

    CTestDerived( int iA, int iB, int iC, int iD )
    : CTestBase ( iA, iB )
    , _iC ( iC )
    , _iD ( iD )
    {}

    int SumDerived( void )
    {
        return _iA + _iB + _iC + _iD;
    }
};

int main( int argc, char* argv[] )
{
    CTestBase       cTestBase   ( argc, argc + 1 );
    CTestDerived    cTestDerived( argc, argc + 1, argc + 2, argc + 3 );

    return cTestBase.SumBase() + cTestDerived.SumBase() + cTestDerived.SumDerived();
}